Index: contrib/OpenWRT/packages/freeDiameter/Makefile
===================================================================
--- contrib/OpenWRT/packages/freeDiameter/Makefile	(revision 660)
+++ contrib/OpenWRT/packages/freeDiameter/Makefile	(revision 662)
@@ -2,5 +2,5 @@
 # Software License Agreement (BSD License)
 #
-# Copyright (c) 2010, WIDE Project and NICT
+# Copyright (c) 2011, WIDE Project and NICT
 # All rights reserved.
 #
Index: extensions/_sample/hello.cpp
===================================================================
--- extensions/_sample/hello.cpp	(revision 653)
+++ extensions/_sample/hello.cpp	(revision 662)
@@ -3,5 +3,5 @@
 * Author: Sebastien Decugis <sdecugis@nict.go.jp>							 *
 *													 *
-* Copyright (c) 2009, WIDE Project and NICT								 *
+* Copyright (c) 2011, WIDE Project and NICT								 *
 * All rights reserved.											 *
 * 													 *
Index: extensions/_sample/sample.c
===================================================================
--- extensions/_sample/sample.c	(revision 653)
+++ extensions/_sample/sample.c	(revision 662)
@@ -3,5 +3,5 @@
 * Author: Sebastien Decugis <sdecugis@nict.go.jp>							 *
 *													 *
-* Copyright (c) 2009, WIDE Project and NICT								 *
+* Copyright (c) 2011, WIDE Project and NICT								 *
 * All rights reserved.											 *
 * 													 *
Index: extensions/dbg_interactive/dbg_interactive.c
===================================================================
--- extensions/dbg_interactive/dbg_interactive.c	(revision 658)
+++ extensions/dbg_interactive/dbg_interactive.c	(revision 662)
@@ -3,5 +3,5 @@
 * Author: Sebastien Decugis <sdecugis@nict.go.jp>							 *
 *													 *
-* Copyright (c) 2010, WIDE Project and NICT								 *
+* Copyright (c) 2011, WIDE Project and NICT								 *
 * All rights reserved.											 *
 * 													 *
Index: extensions/dbg_interactive/dbg_interactive.i
===================================================================
--- extensions/dbg_interactive/dbg_interactive.i	(revision 658)
+++ extensions/dbg_interactive/dbg_interactive.i	(revision 662)
@@ -6,5 +6,5 @@
 * Author: Sebastien Decugis <sdecugis@nict.go.jp>							 *
 *													 *
-* Copyright (c) 2010, WIDE Project and NICT								 *
+* Copyright (c) 2011, WIDE Project and NICT								 *
 * All rights reserved.											 *
 * 													 *
Index: extensions/dbg_interactive/messages.i
===================================================================
--- extensions/dbg_interactive/messages.i	(revision 649)
+++ extensions/dbg_interactive/messages.i	(revision 662)
@@ -3,5 +3,5 @@
 * Author: Sebastien Decugis <sdecugis@nict.go.jp>							 *
 *													 *
-* Copyright (c) 2010, WIDE Project and NICT								 *
+* Copyright (c) 2011, WIDE Project and NICT								 *
 * All rights reserved.											 *
 * 													 *
Index: extensions/dbg_monitor/dbg_monitor.c
===================================================================
--- extensions/dbg_monitor/dbg_monitor.c	(revision 658)
+++ extensions/dbg_monitor/dbg_monitor.c	(revision 662)
@@ -3,5 +3,5 @@
 * Author: Sebastien Decugis <sdecugis@nict.go.jp>							 *
 *													 *
-* Copyright (c) 2010, WIDE Project and NICT								 *
+* Copyright (c) 2011, WIDE Project and NICT								 *
 * All rights reserved.											 *
 * 													 *
Index: extensions/dict_eap/dict_eap.c
===================================================================
--- extensions/dict_eap/dict_eap.c	(revision 658)
+++ extensions/dict_eap/dict_eap.c	(revision 662)
@@ -3,5 +3,5 @@
 * Author: Sebastien Decugis <sdecugis@nict.go.jp>							 *
 *													 *
-* Copyright (c) 2009, WIDE Project and NICT								 *
+* Copyright (c) 2011, WIDE Project and NICT								 *
 * All rights reserved.											 *
 * 													 *
Index: extensions/dict_legacy_xml/dict_lxml_xml.c
===================================================================
--- extensions/dict_legacy_xml/dict_lxml_xml.c	(revision 658)
+++ extensions/dict_legacy_xml/dict_lxml_xml.c	(revision 662)
@@ -3,5 +3,5 @@
 * Author: Sebastien Decugis <sdecugis@nict.go.jp>							 *
 *													 *
-* Copyright (c) 2010, WIDE Project and NICT								 *
+* Copyright (c) 2011, WIDE Project and NICT								 *
 * All rights reserved.											 *
 * 													 *
Index: extensions/dict_nasreq/dict_nasreq.c
===================================================================
--- extensions/dict_nasreq/dict_nasreq.c	(revision 658)
+++ extensions/dict_nasreq/dict_nasreq.c	(revision 662)
@@ -3,5 +3,5 @@
 * Author: Sebastien Decugis <sdecugis@nict.go.jp>							 *
 *													 *
-* Copyright (c) 2010, WIDE Project and NICT								 *
+* Copyright (c) 2011, WIDE Project and NICT								 *
 * All rights reserved.											 *
 * 													 *
Index: extensions/test_acct/test_acct.c
===================================================================
--- extensions/test_acct/test_acct.c	(revision 652)
+++ extensions/test_acct/test_acct.c	(revision 662)
@@ -3,5 +3,5 @@
 * Author: Sebastien Decugis <sdecugis@nict.go.jp>							 *
 *													 *
-* Copyright (c) 2010, WIDE Project and NICT								 *
+* Copyright (c) 2011, WIDE Project and NICT								 *
 * All rights reserved.											 *
 * 													 *
Index: extensions/test_app/ta_bench.c
===================================================================
--- extensions/test_app/ta_bench.c	(revision 658)
+++ extensions/test_app/ta_bench.c	(revision 662)
@@ -3,5 +3,5 @@
 * Author: Sebastien Decugis <sdecugis@nict.go.jp>							 *
 *													 *
-* Copyright (c) 2010, WIDE Project and NICT								 *
+* Copyright (c) 2011, WIDE Project and NICT								 *
 * All rights reserved.											 *
 * 													 *
Index: extensions/test_app/ta_cli.c
===================================================================
--- extensions/test_app/ta_cli.c	(revision 658)
+++ extensions/test_app/ta_cli.c	(revision 662)
@@ -3,5 +3,5 @@
 * Author: Sebastien Decugis <sdecugis@nict.go.jp>							 *
 *													 *
-* Copyright (c) 2010, WIDE Project and NICT								 *
+* Copyright (c) 2011, WIDE Project and NICT								 *
 * All rights reserved.											 *
 * 													 *
Index: extensions/test_app/ta_conf.l
===================================================================
--- extensions/test_app/ta_conf.l	(revision 648)
+++ extensions/test_app/ta_conf.l	(revision 662)
@@ -3,5 +3,5 @@
 * Author: Sebastien Decugis <sdecugis@nict.go.jp>							 *
 *													 *
-* Copyright (c) 2010, WIDE Project and NICT								 *
+* Copyright (c) 2011, WIDE Project and NICT								 *
 * All rights reserved.											 *
 * 													 *
Index: extensions/test_app/ta_conf.y
===================================================================
--- extensions/test_app/ta_conf.y	(revision 648)
+++ extensions/test_app/ta_conf.y	(revision 662)
@@ -3,5 +3,5 @@
 * Author: Sebastien Decugis <sdecugis@nict.go.jp>							 *
 *													 *
-* Copyright (c) 2010, WIDE Project and NICT								 *
+* Copyright (c) 2011, WIDE Project and NICT								 *
 * All rights reserved.											 *
 * 													 *
Index: freeDiameterd/main.c
===================================================================
--- freeDiameterd/main.c	(revision 658)
+++ freeDiameterd/main.c	(revision 662)
@@ -3,5 +3,5 @@
 * Author: Sebastien Decugis <sdecugis@nict.go.jp>							 *
 *													 *
-* Copyright (c) 2010, WIDE Project and NICT								 *
+* Copyright (c) 2011, WIDE Project and NICT								 *
 * All rights reserved.											 *
 * 													 *
Index: include/freeDiameter/freeDiameter-host.h.in
===================================================================
--- include/freeDiameter/freeDiameter-host.h.in	(revision 658)
+++ include/freeDiameter/freeDiameter-host.h.in	(revision 662)
@@ -3,5 +3,5 @@
 * Author: Sebastien Decugis <sdecugis@nict.go.jp>							 *
 *													 *
-* Copyright (c) 2010, WIDE Project and NICT								 *
+* Copyright (c) 2011, WIDE Project and NICT								 *
 * All rights reserved.											 *
 * 													 *
Index: libfdcore/apps.c
===================================================================
--- libfdcore/apps.c	(revision 658)
+++ libfdcore/apps.c	(revision 662)
@@ -3,5 +3,5 @@
 * Author: Sebastien Decugis <sdecugis@nict.go.jp>							 *
 *													 *
-* Copyright (c) 2010, WIDE Project and NICT								 *
+* Copyright (c) 2011, WIDE Project and NICT								 *
 * All rights reserved.											 *
 * 													 *
Index: libfdcore/cnxctx.c
===================================================================
--- libfdcore/cnxctx.c	(revision 658)
+++ libfdcore/cnxctx.c	(revision 662)
@@ -3,5 +3,5 @@
 * Author: Sebastien Decugis <sdecugis@nict.go.jp>							 *
 *													 *
-* Copyright (c) 2010, WIDE Project and NICT								 *
+* Copyright (c) 2011, WIDE Project and NICT								 *
 * All rights reserved.											 *
 * 													 *
Index: libfdcore/cnxctx.h
===================================================================
--- libfdcore/cnxctx.h	(revision 658)
+++ libfdcore/cnxctx.h	(revision 662)
@@ -3,5 +3,5 @@
 * Author: Sebastien Decugis <sdecugis@nict.go.jp>							 *
 *													 *
-* Copyright (c) 2010, WIDE Project and NICT								 *
+* Copyright (c) 2011, WIDE Project and NICT								 *
 * All rights reserved.											 *
 * 													 *
Index: libfdcore/config.c
===================================================================
--- libfdcore/config.c	(revision 658)
+++ libfdcore/config.c	(revision 662)
@@ -3,5 +3,5 @@
 * Author: Sebastien Decugis <sdecugis@nict.go.jp>							 *
 *													 *
-* Copyright (c) 2010, WIDE Project and NICT								 *
+* Copyright (c) 2011, WIDE Project and NICT								 *
 * All rights reserved.											 *
 * 													 *
Index: libfdcore/core.c
===================================================================
--- libfdcore/core.c	(revision 658)
+++ libfdcore/core.c	(revision 662)
@@ -3,5 +3,5 @@
 * Author: Sebastien Decugis <sdecugis@nict.go.jp>							 *
 *													 *
-* Copyright (c) 2009, WIDE Project and NICT								 *
+* Copyright (c) 2011, WIDE Project and NICT								 *
 * All rights reserved.											 *
 * 													 *
Index: libfdcore/dict_base_proto.c
===================================================================
--- libfdcore/dict_base_proto.c	(revision 658)
+++ libfdcore/dict_base_proto.c	(revision 662)
@@ -3,5 +3,5 @@
 * Author: Sebastien Decugis <sdecugis@nict.go.jp>							 *
 *													 *
-* Copyright (c) 2010, WIDE Project and NICT								 *
+* Copyright (c) 2011, WIDE Project and NICT								 *
 * All rights reserved.											 *
 * 													 *
Index: libfdcore/endpoints.c
===================================================================
--- libfdcore/endpoints.c	(revision 658)
+++ libfdcore/endpoints.c	(revision 662)
@@ -3,5 +3,5 @@
 * Author: Sebastien Decugis <sdecugis@nict.go.jp>							 *
 *													 *
-* Copyright (c) 2010, WIDE Project and NICT								 *
+* Copyright (c) 2011, WIDE Project and NICT								 *
 * All rights reserved.											 *
 * 													 *
Index: libfdcore/events.c
===================================================================
--- libfdcore/events.c	(revision 658)
+++ libfdcore/events.c	(revision 662)
@@ -3,5 +3,5 @@
 * Author: Sebastien Decugis <sdecugis@nict.go.jp>							 *
 *													 *
-* Copyright (c) 2009, WIDE Project and NICT								 *
+* Copyright (c) 2011, WIDE Project and NICT								 *
 * All rights reserved.											 *
 * 													 *
Index: libfdcore/extensions.c
===================================================================
--- libfdcore/extensions.c	(revision 658)
+++ libfdcore/extensions.c	(revision 662)
@@ -3,5 +3,5 @@
 * Author: Sebastien Decugis <sdecugis@nict.go.jp>							 *
 *													 *
-* Copyright (c) 2010, WIDE Project and NICT								 *
+* Copyright (c) 2011, WIDE Project and NICT								 *
 * All rights reserved.											 *
 * 													 *
Index: libfdcore/fdcore-internal.h
===================================================================
--- libfdcore/fdcore-internal.h	(revision 658)
+++ libfdcore/fdcore-internal.h	(revision 662)
@@ -3,5 +3,5 @@
 * Author: Sebastien Decugis <sdecugis@nict.go.jp>							 *
 *													 *
-* Copyright (c) 2010, WIDE Project and NICT								 *
+* Copyright (c) 2011, WIDE Project and NICT								 *
 * All rights reserved.											 *
 * 													 *
Index: libfdcore/fdd.l
===================================================================
--- libfdcore/fdd.l	(revision 658)
+++ libfdcore/fdd.l	(revision 662)
@@ -3,5 +3,5 @@
 * Author: Sebastien Decugis <sdecugis@nict.go.jp>							 *
 *													 *
-* Copyright (c) 2010, WIDE Project and NICT								 *
+* Copyright (c) 2011, WIDE Project and NICT								 *
 * All rights reserved.											 *
 * 													 *
Index: libfdcore/fdd.y
===================================================================
--- libfdcore/fdd.y	(revision 658)
+++ libfdcore/fdd.y	(revision 662)
@@ -3,5 +3,5 @@
 * Author: Sebastien Decugis <sdecugis@nict.go.jp>							 *
 *													 *
-* Copyright (c) 2010, WIDE Project and NICT								 *
+* Copyright (c) 2011, WIDE Project and NICT								 *
 * All rights reserved.											 *
 * 													 *
Index: libfdcore/p_ce.c
===================================================================
--- libfdcore/p_ce.c	(revision 658)
+++ libfdcore/p_ce.c	(revision 662)
@@ -3,5 +3,5 @@
 * Author: Sebastien Decugis <sdecugis@nict.go.jp>							 *
 *													 *
-* Copyright (c) 2010, WIDE Project and NICT								 *
+* Copyright (c) 2011, WIDE Project and NICT								 *
 * All rights reserved.											 *
 * 													 *
Index: libfdcore/p_cnx.c
===================================================================
--- libfdcore/p_cnx.c	(revision 658)
+++ libfdcore/p_cnx.c	(revision 662)
@@ -3,5 +3,5 @@
 * Author: Sebastien Decugis <sdecugis@nict.go.jp>							 *
 *													 *
-* Copyright (c) 2010, WIDE Project and NICT								 *
+* Copyright (c) 2011, WIDE Project and NICT								 *
 * All rights reserved.											 *
 * 													 *
Index: libfdcore/p_dp.c
===================================================================
--- libfdcore/p_dp.c	(revision 658)
+++ libfdcore/p_dp.c	(revision 662)
@@ -3,5 +3,5 @@
 * Author: Sebastien Decugis <sdecugis@nict.go.jp>							 *
 *													 *
-* Copyright (c) 2010, WIDE Project and NICT								 *
+* Copyright (c) 2011, WIDE Project and NICT								 *
 * All rights reserved.											 *
 * 													 *
Index: libfdcore/p_dw.c
===================================================================
--- libfdcore/p_dw.c	(revision 658)
+++ libfdcore/p_dw.c	(revision 662)
@@ -3,5 +3,5 @@
 * Author: Sebastien Decugis <sdecugis@nict.go.jp>							 *
 *													 *
-* Copyright (c) 2010, WIDE Project and NICT								 *
+* Copyright (c) 2011, WIDE Project and NICT								 *
 * All rights reserved.											 *
 * 													 *
Index: libfdcore/p_expiry.c
===================================================================
--- libfdcore/p_expiry.c	(revision 658)
+++ libfdcore/p_expiry.c	(revision 662)
@@ -3,5 +3,5 @@
 * Author: Sebastien Decugis <sdecugis@nict.go.jp>							 *
 *													 *
-* Copyright (c) 2010, WIDE Project and NICT								 *
+* Copyright (c) 2011, WIDE Project and NICT								 *
 * All rights reserved.											 *
 * 													 *
Index: libfdcore/p_out.c
===================================================================
--- libfdcore/p_out.c	(revision 658)
+++ libfdcore/p_out.c	(revision 662)
@@ -3,5 +3,5 @@
 * Author: Sebastien Decugis <sdecugis@nict.go.jp>							 *
 *													 *
-* Copyright (c) 2010, WIDE Project and NICT								 *
+* Copyright (c) 2011, WIDE Project and NICT								 *
 * All rights reserved.											 *
 * 													 *
Index: libfdcore/p_psm.c
===================================================================
--- libfdcore/p_psm.c	(revision 658)
+++ libfdcore/p_psm.c	(revision 662)
@@ -3,5 +3,5 @@
 * Author: Sebastien Decugis <sdecugis@nict.go.jp>							 *
 *													 *
-* Copyright (c) 2010, WIDE Project and NICT								 *
+* Copyright (c) 2011, WIDE Project and NICT								 *
 * All rights reserved.											 *
 * 													 *
Index: libfdcore/p_sr.c
===================================================================
--- libfdcore/p_sr.c	(revision 658)
+++ libfdcore/p_sr.c	(revision 662)
@@ -3,5 +3,5 @@
 * Author: Sebastien Decugis <sdecugis@nict.go.jp>							 *
 *													 *
-* Copyright (c) 2010, WIDE Project and NICT								 *
+* Copyright (c) 2011, WIDE Project and NICT								 *
 * All rights reserved.											 *
 * 													 *
Index: libfdcore/peers.c
===================================================================
--- libfdcore/peers.c	(revision 658)
+++ libfdcore/peers.c	(revision 662)
@@ -3,5 +3,5 @@
 * Author: Sebastien Decugis <sdecugis@nict.go.jp>							 *
 *													 *
-* Copyright (c) 2010, WIDE Project and NICT								 *
+* Copyright (c) 2011, WIDE Project and NICT								 *
 * All rights reserved.											 *
 * 													 *
Index: libfdcore/queues.c
===================================================================
--- libfdcore/queues.c	(revision 658)
+++ libfdcore/queues.c	(revision 662)
@@ -3,5 +3,5 @@
 * Author: Sebastien Decugis <sdecugis@nict.go.jp>							 *
 *													 *
-* Copyright (c) 2009, WIDE Project and NICT								 *
+* Copyright (c) 2011, WIDE Project and NICT								 *
 * All rights reserved.											 *
 * 													 *
Index: libfdcore/routing_dispatch.c
===================================================================
--- libfdcore/routing_dispatch.c	(revision 658)
+++ libfdcore/routing_dispatch.c	(revision 662)
@@ -3,5 +3,5 @@
 * Author: Sebastien Decugis <sdecugis@nict.go.jp>							 *
 *													 *
-* Copyright (c) 2010, WIDE Project and NICT								 *
+* Copyright (c) 2011, WIDE Project and NICT								 *
 * All rights reserved.											 *
 * 													 *
Index: libfdcore/sctp.c
===================================================================
--- libfdcore/sctp.c	(revision 658)
+++ libfdcore/sctp.c	(revision 662)
@@ -3,5 +3,5 @@
 * Author: Sebastien Decugis <sdecugis@nict.go.jp>							 *
 *													 *
-* Copyright (c) 2010, WIDE Project and NICT								 *
+* Copyright (c) 2011, WIDE Project and NICT								 *
 * All rights reserved.											 *
 * 													 *
Index: libfdcore/sctps.c
===================================================================
--- libfdcore/sctps.c	(revision 658)
+++ libfdcore/sctps.c	(revision 662)
@@ -3,5 +3,5 @@
 * Author: Sebastien Decugis <sdecugis@nict.go.jp>							 *
 *													 *
-* Copyright (c) 2010, WIDE Project and NICT								 *
+* Copyright (c) 2011, WIDE Project and NICT								 *
 * All rights reserved.											 *
 * 													 *
Index: libfdcore/server.c
===================================================================
--- libfdcore/server.c	(revision 658)
+++ libfdcore/server.c	(revision 662)
@@ -3,5 +3,5 @@
 * Author: Sebastien Decugis <sdecugis@nict.go.jp>							 *
 *													 *
-* Copyright (c) 2010, WIDE Project and NICT								 *
+* Copyright (c) 2011, WIDE Project and NICT								 *
 * All rights reserved.											 *
 * 													 *
Index: libfdcore/tcp.c
===================================================================
--- libfdcore/tcp.c	(revision 658)
+++ libfdcore/tcp.c	(revision 662)
@@ -3,5 +3,5 @@
 * Author: Sebastien Decugis <sdecugis@nict.go.jp>							 *
 *													 *
-* Copyright (c) 2010, WIDE Project and NICT								 *
+* Copyright (c) 2011, WIDE Project and NICT								 *
 * All rights reserved.											 *
 * 													 *
Index: libfdproto/dictionary.c
===================================================================
--- libfdproto/dictionary.c	(revision 658)
+++ libfdproto/dictionary.c	(revision 662)
@@ -3,5 +3,5 @@
 * Author: Sebastien Decugis <sdecugis@nict.go.jp>							 *
 *													 *
-* Copyright (c) 2010, WIDE Project and NICT								 *
+* Copyright (c) 2011, WIDE Project and NICT								 *
 * All rights reserved.											 *
 * 													 *
Index: libfdproto/dispatch.c
===================================================================
--- libfdproto/dispatch.c	(revision 658)
+++ libfdproto/dispatch.c	(revision 662)
@@ -3,5 +3,5 @@
 * Author: Sebastien Decugis <sdecugis@nict.go.jp>							 *
 *													 *
-* Copyright (c) 2010, WIDE Project and NICT								 *
+* Copyright (c) 2011, WIDE Project and NICT								 *
 * All rights reserved.											 *
 * 													 *
Index: libfdproto/fdproto-internal.h
===================================================================
--- libfdproto/fdproto-internal.h	(revision 658)
+++ libfdproto/fdproto-internal.h	(revision 662)
@@ -3,5 +3,5 @@
 * Author: Sebastien Decugis <sdecugis@nict.go.jp>							 *
 *													 *
-* Copyright (c) 2010, WIDE Project and NICT								 *
+* Copyright (c) 2011, WIDE Project and NICT								 *
 * All rights reserved.											 *
 * 													 *
Index: libfdproto/fifo.c
===================================================================
--- libfdproto/fifo.c	(revision 658)
+++ libfdproto/fifo.c	(revision 662)
@@ -3,5 +3,5 @@
 * Author: Sebastien Decugis <sdecugis@nict.go.jp>							 *
 *													 *
-* Copyright (c) 2010, WIDE Project and NICT								 *
+* Copyright (c) 2011, WIDE Project and NICT								 *
 * All rights reserved.											 *
 * 													 *
Index: libfdproto/init.c
===================================================================
--- libfdproto/init.c	(revision 658)
+++ libfdproto/init.c	(revision 662)
@@ -3,5 +3,5 @@
 * Author: Sebastien Decugis <sdecugis@nict.go.jp>							 *
 *													 *
-* Copyright (c) 2010, WIDE Project and NICT								 *
+* Copyright (c) 2011, WIDE Project and NICT								 *
 * All rights reserved.											 *
 * 													 *
Index: libfdproto/lists.c
===================================================================
--- libfdproto/lists.c	(revision 658)
+++ libfdproto/lists.c	(revision 662)
@@ -3,5 +3,5 @@
 * Author: Sebastien Decugis <sdecugis@nict.go.jp>							 *
 *													 *
-* Copyright (c) 2009, WIDE Project and NICT								 *
+* Copyright (c) 2011, WIDE Project and NICT								 *
 * All rights reserved.											 *
 * 													 *
Index: libfdproto/log.c
===================================================================
--- libfdproto/log.c	(revision 658)
+++ libfdproto/log.c	(revision 662)
@@ -3,5 +3,5 @@
 * Author: Sebastien Decugis <sdecugis@nict.go.jp>							 *
 *													 *
-* Copyright (c) 2010, WIDE Project and NICT								 *
+* Copyright (c) 2011, WIDE Project and NICT								 *
 * All rights reserved.											 *
 * 													 *
Index: libfdproto/rt_data.c
===================================================================
--- libfdproto/rt_data.c	(revision 658)
+++ libfdproto/rt_data.c	(revision 662)
@@ -3,5 +3,5 @@
 * Author: Sebastien Decugis <sdecugis@nict.go.jp>							 *
 *													 *
-* Copyright (c) 2010, WIDE Project and NICT								 *
+* Copyright (c) 2011, WIDE Project and NICT								 *
 * All rights reserved.											 *
 * 													 *
Index: libfdproto/sessions.c
===================================================================
--- libfdproto/sessions.c	(revision 658)
+++ libfdproto/sessions.c	(revision 662)
@@ -3,5 +3,5 @@
 * Author: Sebastien Decugis <sdecugis@nict.go.jp>							 *
 *													 *
-* Copyright (c) 2010, WIDE Project and NICT								 *
+* Copyright (c) 2011, WIDE Project and NICT								 *
 * All rights reserved.											 *
 * 													 *
Index: tests/testappacct.c
===================================================================
--- tests/testappacct.c	(revision 658)
+++ tests/testappacct.c	(revision 662)
@@ -3,5 +3,5 @@
 * Author: Sebastien Decugis <sdecugis@nict.go.jp>							 *
 *													 *
-* Copyright (c) 2010, WIDE Project and NICT								 *
+* Copyright (c) 2011, WIDE Project and NICT								 *
 * All rights reserved.											 *
 * 													 *
Index: tests/testcnx.c
===================================================================
--- tests/testcnx.c	(revision 658)
+++ tests/testcnx.c	(revision 662)
@@ -3,5 +3,5 @@
 * Author: Sebastien Decugis <sdecugis@nict.go.jp>							 *
 *													 *
-* Copyright (c) 2010, WIDE Project and NICT								 *
+* Copyright (c) 2011, WIDE Project and NICT								 *
 * All rights reserved.											 *
 * 													 *
Index: tests/testdict.c
===================================================================
--- tests/testdict.c	(revision 658)
+++ tests/testdict.c	(revision 662)
@@ -3,5 +3,5 @@
 * Author: Sebastien Decugis <sdecugis@nict.go.jp>							 *
 *													 *
-* Copyright (c) 2010, WIDE Project and NICT								 *
+* Copyright (c) 2011, WIDE Project and NICT								 *
 * All rights reserved.											 *
 * 													 *
Index: tests/testdisp.c
===================================================================
--- tests/testdisp.c	(revision 658)
+++ tests/testdisp.c	(revision 662)
@@ -3,5 +3,5 @@
 * Author: Sebastien Decugis <sdecugis@nict.go.jp>							 *
 *													 *
-* Copyright (c) 2010, WIDE Project and NICT								 *
+* Copyright (c) 2011, WIDE Project and NICT								 *
 * All rights reserved.											 *
 * 													 *
Index: tests/testfifo.c
===================================================================
--- tests/testfifo.c	(revision 658)
+++ tests/testfifo.c	(revision 662)
@@ -3,5 +3,5 @@
 * Author: Sebastien Decugis <sdecugis@nict.go.jp>							 *
 *													 *
-* Copyright (c) 2010, WIDE Project and NICT								 *
+* Copyright (c) 2011, WIDE Project and NICT								 *
 * All rights reserved.											 *
 * 													 *
Index: tests/testlist.c
===================================================================
--- tests/testlist.c	(revision 658)
+++ tests/testlist.c	(revision 662)
@@ -3,5 +3,5 @@
 * Author: Sebastien Decugis <sdecugis@nict.go.jp>							 *
 *													 *
-* Copyright (c) 2009, WIDE Project and NICT								 *
+* Copyright (c) 2011, WIDE Project and NICT								 *
 * All rights reserved.											 *
 * 													 *
Index: tests/testmesg.c
===================================================================
--- tests/testmesg.c	(revision 658)
+++ tests/testmesg.c	(revision 662)
@@ -3,5 +3,5 @@
 * Author: Sebastien Decugis <sdecugis@nict.go.jp>							 *
 *													 *
-* Copyright (c) 2010, WIDE Project and NICT								 *
+* Copyright (c) 2011, WIDE Project and NICT								 *
 * All rights reserved.											 *
 * 													 *
Index: tests/tests.h
===================================================================
--- tests/tests.h	(revision 658)
+++ tests/tests.h	(revision 662)
@@ -3,5 +3,5 @@
 * Author: Sebastien Decugis <sdecugis@nict.go.jp>							 *
 *													 *
-* Copyright (c) 2010, WIDE Project and NICT								 *
+* Copyright (c) 2011, WIDE Project and NICT								 *
 * All rights reserved.											 *
 * 													 *
Index: tests/testsctp.c
===================================================================
--- tests/testsctp.c	(revision 658)
+++ tests/testsctp.c	(revision 662)
@@ -3,5 +3,5 @@
 * Author: Sebastien Decugis <sdecugis@nict.go.jp>							 *
 *													 *
-* Copyright (c) 2010, WIDE Project and NICT								 *
+* Copyright (c) 2011, WIDE Project and NICT								 *
 * All rights reserved.											 *
 * 													 *
Index: tests/testsess.c
===================================================================
--- tests/testsess.c	(revision 658)
+++ tests/testsess.c	(revision 662)
@@ -3,5 +3,5 @@
 * Author: Sebastien Decugis <sdecugis@nict.go.jp>							 *
 *													 *
-* Copyright (c) 2010, WIDE Project and NICT								 *
+* Copyright (c) 2011, WIDE Project and NICT								 *
 * All rights reserved.											 *
 * 													 *