Index: extensions/_sample/fini.c
===================================================================
--- extensions/_sample/fini.c	(revision 10)
+++ extensions/_sample/fini.c	(revision 258)
@@ -3,5 +3,5 @@
 * Author: Sebastien Decugis <sdecugis@nict.go.jp>							 *
 *													 *
-* Copyright (c) 2008, WIDE Project and NICT								 *
+* Copyright (c) 2009, WIDE Project and NICT								 *
 * All rights reserved.											 *
 * 													 *
Index: extensions/acl_wl/acl_wl.c
===================================================================
--- extensions/acl_wl/acl_wl.c	(revision 162)
+++ extensions/acl_wl/acl_wl.c	(revision 258)
@@ -3,5 +3,5 @@
 * Author: Sebastien Decugis <sdecugis@nict.go.jp>							 *
 *													 *
-* Copyright (c) 2009, WIDE Project and NICT								 *
+* Copyright (c) 2010, WIDE Project and NICT								 *
 * All rights reserved.											 *
 * 													 *
Index: extensions/acl_wl/acl_wl.h
===================================================================
--- extensions/acl_wl/acl_wl.h	(revision 161)
+++ extensions/acl_wl/acl_wl.h	(revision 258)
@@ -3,5 +3,5 @@
 * Author: Sebastien Decugis <sdecugis@nict.go.jp>							 *
 *													 *
-* Copyright (c) 2009, WIDE Project and NICT								 *
+* Copyright (c) 2010, WIDE Project and NICT								 *
 * All rights reserved.											 *
 * 													 *
Index: extensions/acl_wl/aw_conf.l
===================================================================
--- extensions/acl_wl/aw_conf.l	(revision 161)
+++ extensions/acl_wl/aw_conf.l	(revision 258)
@@ -3,5 +3,5 @@
 * Author: Sebastien Decugis <sdecugis@nict.go.jp>							 *
 *													 *
-* Copyright (c) 2009, WIDE Project and NICT								 *
+* Copyright (c) 2010, WIDE Project and NICT								 *
 * All rights reserved.											 *
 * 													 *
Index: extensions/acl_wl/aw_conf.y
===================================================================
--- extensions/acl_wl/aw_conf.y	(revision 161)
+++ extensions/acl_wl/aw_conf.y	(revision 258)
@@ -3,5 +3,5 @@
 * Author: Sebastien Decugis <sdecugis@nict.go.jp>							 *
 *													 *
-* Copyright (c) 2009, WIDE Project and NICT								 *
+* Copyright (c) 2010, WIDE Project and NICT								 *
 * All rights reserved.											 *
 * 													 *
Index: extensions/acl_wl/aw_tree.c
===================================================================
--- extensions/acl_wl/aw_tree.c	(revision 162)
+++ extensions/acl_wl/aw_tree.c	(revision 258)
@@ -3,5 +3,5 @@
 * Author: Sebastien Decugis <sdecugis@nict.go.jp>							 *
 *													 *
-* Copyright (c) 2009, WIDE Project and NICT								 *
+* Copyright (c) 2010, WIDE Project and NICT								 *
 * All rights reserved.											 *
 * 													 *
Index: extensions/app_radgw/hostap_compat.h
===================================================================
--- extensions/app_radgw/hostap_compat.h	(revision 254)
+++ extensions/app_radgw/hostap_compat.h	(revision 258)
@@ -3,5 +3,5 @@
 * Author: Sebastien Decugis <sdecugis@nict.go.jp>							 *
 *													 *
-* Copyright (c) 2009, WIDE Project and NICT								 *
+* Copyright (c) 2010, WIDE Project and NICT								 *
 * All rights reserved.											 *
 * 													 *
Index: extensions/app_radgw/rgw.h
===================================================================
--- extensions/app_radgw/rgw.h	(revision 254)
+++ extensions/app_radgw/rgw.h	(revision 258)
@@ -3,5 +3,5 @@
 * Author: Sebastien Decugis <sdecugis@nict.go.jp>							 *
 *													 *
-* Copyright (c) 2009, WIDE Project and NICT								 *
+* Copyright (c) 2010, WIDE Project and NICT								 *
 * All rights reserved.											 *
 * 													 *
Index: extensions/app_radgw/rgw_clients.c
===================================================================
--- extensions/app_radgw/rgw_clients.c	(revision 254)
+++ extensions/app_radgw/rgw_clients.c	(revision 258)
@@ -3,5 +3,5 @@
 * Author: Sebastien Decugis <sdecugis@nict.go.jp>							 *
 *													 *
-* Copyright (c) 2009, WIDE Project and NICT								 *
+* Copyright (c) 2010, WIDE Project and NICT								 *
 * All rights reserved.											 *
 * 													 *
Index: extensions/app_radgw/rgw_common.h
===================================================================
--- extensions/app_radgw/rgw_common.h	(revision 256)
+++ extensions/app_radgw/rgw_common.h	(revision 258)
@@ -3,5 +3,5 @@
 * Author: Sebastien Decugis <sdecugis@nict.go.jp>							 *
 *													 *
-* Copyright (c) 2009, WIDE Project and NICT								 *
+* Copyright (c) 2010, WIDE Project and NICT								 *
 * All rights reserved.											 *
 * 													 *
Index: extensions/app_radgw/rgw_conf.l
===================================================================
--- extensions/app_radgw/rgw_conf.l	(revision 254)
+++ extensions/app_radgw/rgw_conf.l	(revision 258)
@@ -3,5 +3,5 @@
 * Author: Sebastien Decugis <sdecugis@nict.go.jp>							 *
 *													 *
-* Copyright (c) 2009, WIDE Project and NICT								 *
+* Copyright (c) 2010, WIDE Project and NICT								 *
 * All rights reserved.											 *
 * 													 *
Index: extensions/app_radgw/rgw_conf.y
===================================================================
--- extensions/app_radgw/rgw_conf.y	(revision 254)
+++ extensions/app_radgw/rgw_conf.y	(revision 258)
@@ -3,5 +3,5 @@
 * Author: Sebastien Decugis <sdecugis@nict.go.jp>							 *
 *													 *
-* Copyright (c) 2009, WIDE Project and NICT								 *
+* Copyright (c) 2010, WIDE Project and NICT								 *
 * All rights reserved.											 *
 * 													 *
Index: extensions/app_radgw/rgw_main.c
===================================================================
--- extensions/app_radgw/rgw_main.c	(revision 254)
+++ extensions/app_radgw/rgw_main.c	(revision 258)
@@ -3,5 +3,5 @@
 * Author: Sebastien Decugis <sdecugis@nict.go.jp>							 *
 *													 *
-* Copyright (c) 2009, WIDE Project and NICT								 *
+* Copyright (c) 2010, WIDE Project and NICT								 *
 * All rights reserved.											 *
 * 													 *
Index: extensions/app_radgw/rgw_msg.c
===================================================================
--- extensions/app_radgw/rgw_msg.c	(revision 255)
+++ extensions/app_radgw/rgw_msg.c	(revision 258)
@@ -3,5 +3,5 @@
 * Author: Sebastien Decugis <sdecugis@nict.go.jp>							 *
 *													 *
-* Copyright (c) 2009, WIDE Project and NICT								 *
+* Copyright (c) 2010, WIDE Project and NICT								 *
 * All rights reserved.											 *
 * 													 *
Index: extensions/app_radgw/rgw_msg_attrtype.c
===================================================================
--- extensions/app_radgw/rgw_msg_attrtype.c	(revision 255)
+++ extensions/app_radgw/rgw_msg_attrtype.c	(revision 258)
@@ -3,5 +3,5 @@
 * Author: Sebastien Decugis <sdecugis@nict.go.jp>							 *
 *													 *
-* Copyright (c) 2009, WIDE Project and NICT								 *
+* Copyright (c) 2010, WIDE Project and NICT								 *
 * All rights reserved.											 *
 * 													 *
Index: extensions/app_radgw/rgw_msg_codes.c
===================================================================
--- extensions/app_radgw/rgw_msg_codes.c	(revision 255)
+++ extensions/app_radgw/rgw_msg_codes.c	(revision 258)
@@ -3,5 +3,5 @@
 * Author: Sebastien Decugis <sdecugis@nict.go.jp>							 *
 *													 *
-* Copyright (c) 2009, WIDE Project and NICT								 *
+* Copyright (c) 2010, WIDE Project and NICT								 *
 * All rights reserved.											 *
 * 													 *
Index: extensions/app_radgw/rgw_plugins.c
===================================================================
--- extensions/app_radgw/rgw_plugins.c	(revision 256)
+++ extensions/app_radgw/rgw_plugins.c	(revision 258)
@@ -3,5 +3,5 @@
 * Author: Sebastien Decugis <sdecugis@nict.go.jp>							 *
 *													 *
-* Copyright (c) 2009, WIDE Project and NICT								 *
+* Copyright (c) 2010, WIDE Project and NICT								 *
 * All rights reserved.											 *
 * 													 *
Index: extensions/app_radgw/rgw_servers.c
===================================================================
--- extensions/app_radgw/rgw_servers.c	(revision 254)
+++ extensions/app_radgw/rgw_servers.c	(revision 258)
@@ -3,5 +3,5 @@
 * Author: Sebastien Decugis <sdecugis@nict.go.jp>							 *
 *													 *
-* Copyright (c) 2009, WIDE Project and NICT								 *
+* Copyright (c) 2010, WIDE Project and NICT								 *
 * All rights reserved.											 *
 * 													 *
Index: extensions/app_radgw/rgw_worker.c
===================================================================
--- extensions/app_radgw/rgw_worker.c	(revision 254)
+++ extensions/app_radgw/rgw_worker.c	(revision 258)
@@ -3,5 +3,5 @@
 * Author: Sebastien Decugis <sdecugis@nict.go.jp>							 *
 *													 *
-* Copyright (c) 2009, WIDE Project and NICT								 *
+* Copyright (c) 2010, WIDE Project and NICT								 *
 * All rights reserved.											 *
 * 													 *
Index: extensions/app_radgw/rgwx_auth.c
===================================================================
--- extensions/app_radgw/rgwx_auth.c	(revision 256)
+++ extensions/app_radgw/rgwx_auth.c	(revision 258)
@@ -3,5 +3,5 @@
 * Author: Sebastien Decugis <sdecugis@nict.go.jp>							 *
 *													 *
-* Copyright (c) 2009, WIDE Project and NICT								 *
+* Copyright (c) 2010, WIDE Project and NICT								 *
 * All rights reserved.											 *
 * 													 *
Index: extensions/app_radgw/rgwx_debug.c
===================================================================
--- extensions/app_radgw/rgwx_debug.c	(revision 256)
+++ extensions/app_radgw/rgwx_debug.c	(revision 258)
@@ -3,5 +3,5 @@
 * Author: Sebastien Decugis <sdecugis@nict.go.jp>							 *
 *													 *
-* Copyright (c) 2009, WIDE Project and NICT								 *
+* Copyright (c) 2010, WIDE Project and NICT								 *
 * All rights reserved.											 *
 * 													 *
Index: extensions/app_radgw/rgwx_sample.c
===================================================================
--- extensions/app_radgw/rgwx_sample.c	(revision 256)
+++ extensions/app_radgw/rgwx_sample.c	(revision 258)
@@ -3,5 +3,5 @@
 * Author: Sebastien Decugis <sdecugis@nict.go.jp>							 *
 *													 *
-* Copyright (c) 2009, WIDE Project and NICT								 *
+* Copyright (c) 2010, WIDE Project and NICT								 *
 * All rights reserved.											 *
 * 													 *
Index: extensions/dbg_monitor/dbg_monitor.c
===================================================================
--- extensions/dbg_monitor/dbg_monitor.c	(revision 240)
+++ extensions/dbg_monitor/dbg_monitor.c	(revision 258)
@@ -3,5 +3,5 @@
 * Author: Sebastien Decugis <sdecugis@nict.go.jp>							 *
 *													 *
-* Copyright (c) 2009, WIDE Project and NICT								 *
+* Copyright (c) 2010, WIDE Project and NICT								 *
 * All rights reserved.											 *
 * 													 *
Index: extensions/dbg_rt/dbg_rt.c
===================================================================
--- extensions/dbg_rt/dbg_rt.c	(revision 166)
+++ extensions/dbg_rt/dbg_rt.c	(revision 258)
@@ -3,5 +3,5 @@
 * Author: Sebastien Decugis <sdecugis@nict.go.jp>							 *
 *													 *
-* Copyright (c) 2009, WIDE Project and NICT								 *
+* Copyright (c) 2010, WIDE Project and NICT								 *
 * All rights reserved.											 *
 * 													 *
Index: extensions/rt_default/rt_default-host.h.in
===================================================================
--- extensions/rt_default/rt_default-host.h.in	(revision 168)
+++ extensions/rt_default/rt_default-host.h.in	(revision 258)
@@ -3,5 +3,5 @@
 * Author: Sebastien Decugis <sdecugis@nict.go.jp>							 *
 *													 *
-* Copyright (c) 2009, WIDE Project and NICT								 *
+* Copyright (c) 2010, WIDE Project and NICT								 *
 * All rights reserved.											 *
 * 													 *
Index: extensions/rt_default/rt_default.c
===================================================================
--- extensions/rt_default/rt_default.c	(revision 168)
+++ extensions/rt_default/rt_default.c	(revision 258)
@@ -3,5 +3,5 @@
 * Author: Sebastien Decugis <sdecugis@nict.go.jp>							 *
 *													 *
-* Copyright (c) 2009, WIDE Project and NICT								 *
+* Copyright (c) 2010, WIDE Project and NICT								 *
 * All rights reserved.											 *
 * 													 *
Index: extensions/rt_default/rt_default.h
===================================================================
--- extensions/rt_default/rt_default.h	(revision 168)
+++ extensions/rt_default/rt_default.h	(revision 258)
@@ -3,5 +3,5 @@
 * Author: Sebastien Decugis <sdecugis@nict.go.jp>							 *
 *													 *
-* Copyright (c) 2009, WIDE Project and NICT								 *
+* Copyright (c) 2010, WIDE Project and NICT								 *
 * All rights reserved.											 *
 * 													 *
Index: extensions/rt_default/rtd_conf.l
===================================================================
--- extensions/rt_default/rtd_conf.l	(revision 169)
+++ extensions/rt_default/rtd_conf.l	(revision 258)
@@ -3,5 +3,5 @@
 * Author: Sebastien Decugis <sdecugis@nict.go.jp>							 *
 *													 *
-* Copyright (c) 2009, WIDE Project and NICT								 *
+* Copyright (c) 2010, WIDE Project and NICT								 *
 * All rights reserved.											 *
 * 													 *
Index: extensions/rt_default/rtd_conf.y
===================================================================
--- extensions/rt_default/rtd_conf.y	(revision 169)
+++ extensions/rt_default/rtd_conf.y	(revision 258)
@@ -3,5 +3,5 @@
 * Author: Sebastien Decugis <sdecugis@nict.go.jp>							 *
 *													 *
-* Copyright (c) 2009, WIDE Project and NICT								 *
+* Copyright (c) 2010, WIDE Project and NICT								 *
 * All rights reserved.											 *
 * 													 *
Index: extensions/rt_default/rtd_rules.c
===================================================================
--- extensions/rt_default/rtd_rules.c	(revision 168)
+++ extensions/rt_default/rtd_rules.c	(revision 258)
@@ -3,5 +3,5 @@
 * Author: Sebastien Decugis <sdecugis@nict.go.jp>							 *
 *													 *
-* Copyright (c) 2009, WIDE Project and NICT								 *
+* Copyright (c) 2010, WIDE Project and NICT								 *
 * All rights reserved.											 *
 * 													 *
Index: extensions/test_app/ta_cli.c
===================================================================
--- extensions/test_app/ta_cli.c	(revision 235)
+++ extensions/test_app/ta_cli.c	(revision 258)
@@ -3,5 +3,5 @@
 * Author: Sebastien Decugis <sdecugis@nict.go.jp>							 *
 *													 *
-* Copyright (c) 2009, WIDE Project and NICT								 *
+* Copyright (c) 2010, WIDE Project and NICT								 *
 * All rights reserved.											 *
 * 													 *
Index: extensions/test_app/ta_serv.c
===================================================================
--- extensions/test_app/ta_serv.c	(revision 237)
+++ extensions/test_app/ta_serv.c	(revision 258)
@@ -3,5 +3,5 @@
 * Author: Sebastien Decugis <sdecugis@nict.go.jp>							 *
 *													 *
-* Copyright (c) 2009, WIDE Project and NICT								 *
+* Copyright (c) 2010, WIDE Project and NICT								 *
 * All rights reserved.											 *
 * 													 *
Index: extensions/test_app/test_app.c
===================================================================
--- extensions/test_app/test_app.c	(revision 235)
+++ extensions/test_app/test_app.c	(revision 258)
@@ -3,5 +3,5 @@
 * Author: Sebastien Decugis <sdecugis@nict.go.jp>							 *
 *													 *
-* Copyright (c) 2009, WIDE Project and NICT								 *
+* Copyright (c) 2010, WIDE Project and NICT								 *
 * All rights reserved.											 *
 * 													 *
Index: extensions/test_app/test_app.h
===================================================================
--- extensions/test_app/test_app.h	(revision 235)
+++ extensions/test_app/test_app.h	(revision 258)
@@ -3,5 +3,5 @@
 * Author: Sebastien Decugis <sdecugis@nict.go.jp>							 *
 *													 *
-* Copyright (c) 2009, WIDE Project and NICT								 *
+* Copyright (c) 2010, WIDE Project and NICT								 *
 * All rights reserved.											 *
 * 													 *
Index: freeDiameter/cnxctx.c
===================================================================
--- freeDiameter/cnxctx.c	(revision 251)
+++ freeDiameter/cnxctx.c	(revision 258)
@@ -3,5 +3,5 @@
 * Author: Sebastien Decugis <sdecugis@nict.go.jp>							 *
 *													 *
-* Copyright (c) 2009, WIDE Project and NICT								 *
+* Copyright (c) 2010, WIDE Project and NICT								 *
 * All rights reserved.											 *
 * 													 *
Index: freeDiameter/cnxctx.h
===================================================================
--- freeDiameter/cnxctx.h	(revision 220)
+++ freeDiameter/cnxctx.h	(revision 258)
@@ -3,5 +3,5 @@
 * Author: Sebastien Decugis <sdecugis@nict.go.jp>							 *
 *													 *
-* Copyright (c) 2009, WIDE Project and NICT								 *
+* Copyright (c) 2010, WIDE Project and NICT								 *
 * All rights reserved.											 *
 * 													 *
Index: freeDiameter/config.c
===================================================================
--- freeDiameter/config.c	(revision 253)
+++ freeDiameter/config.c	(revision 258)
@@ -3,5 +3,5 @@
 * Author: Sebastien Decugis <sdecugis@nict.go.jp>							 *
 *													 *
-* Copyright (c) 2009, WIDE Project and NICT								 *
+* Copyright (c) 2010, WIDE Project and NICT								 *
 * All rights reserved.											 *
 * 													 *
Index: freeDiameter/dict_base_proto.c
===================================================================
--- freeDiameter/dict_base_proto.c	(revision 190)
+++ freeDiameter/dict_base_proto.c	(revision 258)
@@ -3,5 +3,5 @@
 * Author: Sebastien Decugis <sdecugis@nict.go.jp>							 *
 *													 *
-* Copyright (c) 2009, WIDE Project and NICT								 *
+* Copyright (c) 2010, WIDE Project and NICT								 *
 * All rights reserved.											 *
 * 													 *
Index: freeDiameter/endpoints.c
===================================================================
--- freeDiameter/endpoints.c	(revision 210)
+++ freeDiameter/endpoints.c	(revision 258)
@@ -3,5 +3,5 @@
 * Author: Sebastien Decugis <sdecugis@nict.go.jp>							 *
 *													 *
-* Copyright (c) 2009, WIDE Project and NICT								 *
+* Copyright (c) 2010, WIDE Project and NICT								 *
 * All rights reserved.											 *
 * 													 *
Index: freeDiameter/fD.h
===================================================================
--- freeDiameter/fD.h	(revision 229)
+++ freeDiameter/fD.h	(revision 258)
@@ -3,5 +3,5 @@
 * Author: Sebastien Decugis <sdecugis@nict.go.jp>							 *
 *													 *
-* Copyright (c) 2009, WIDE Project and NICT								 *
+* Copyright (c) 2010, WIDE Project and NICT								 *
 * All rights reserved.											 *
 * 													 *
Index: freeDiameter/fdd.l
===================================================================
--- freeDiameter/fdd.l	(revision 253)
+++ freeDiameter/fdd.l	(revision 258)
@@ -3,5 +3,5 @@
 * Author: Sebastien Decugis <sdecugis@nict.go.jp>							 *
 *													 *
-* Copyright (c) 2009, WIDE Project and NICT								 *
+* Copyright (c) 2010, WIDE Project and NICT								 *
 * All rights reserved.											 *
 * 													 *
Index: freeDiameter/fdd.y
===================================================================
--- freeDiameter/fdd.y	(revision 253)
+++ freeDiameter/fdd.y	(revision 258)
@@ -3,5 +3,5 @@
 * Author: Sebastien Decugis <sdecugis@nict.go.jp>							 *
 *													 *
-* Copyright (c) 2009, WIDE Project and NICT								 *
+* Copyright (c) 2010, WIDE Project and NICT								 *
 * All rights reserved.											 *
 * 													 *
Index: freeDiameter/main.c
===================================================================
--- freeDiameter/main.c	(revision 253)
+++ freeDiameter/main.c	(revision 258)
@@ -3,5 +3,5 @@
 * Author: Sebastien Decugis <sdecugis@nict.go.jp>							 *
 *													 *
-* Copyright (c) 2009, WIDE Project and NICT								 *
+* Copyright (c) 2010, WIDE Project and NICT								 *
 * All rights reserved.											 *
 * 													 *
Index: freeDiameter/p_ce.c
===================================================================
--- freeDiameter/p_ce.c	(revision 233)
+++ freeDiameter/p_ce.c	(revision 258)
@@ -3,5 +3,5 @@
 * Author: Sebastien Decugis <sdecugis@nict.go.jp>							 *
 *													 *
-* Copyright (c) 2009, WIDE Project and NICT								 *
+* Copyright (c) 2010, WIDE Project and NICT								 *
 * All rights reserved.											 *
 * 													 *
Index: freeDiameter/p_cnx.c
===================================================================
--- freeDiameter/p_cnx.c	(revision 246)
+++ freeDiameter/p_cnx.c	(revision 258)
@@ -3,5 +3,5 @@
 * Author: Sebastien Decugis <sdecugis@nict.go.jp>							 *
 *													 *
-* Copyright (c) 2009, WIDE Project and NICT								 *
+* Copyright (c) 2010, WIDE Project and NICT								 *
 * All rights reserved.											 *
 * 													 *
Index: freeDiameter/p_dp.c
===================================================================
--- freeDiameter/p_dp.c	(revision 229)
+++ freeDiameter/p_dp.c	(revision 258)
@@ -3,5 +3,5 @@
 * Author: Sebastien Decugis <sdecugis@nict.go.jp>							 *
 *													 *
-* Copyright (c) 2009, WIDE Project and NICT								 *
+* Copyright (c) 2010, WIDE Project and NICT								 *
 * All rights reserved.											 *
 * 													 *
Index: freeDiameter/p_dw.c
===================================================================
--- freeDiameter/p_dw.c	(revision 229)
+++ freeDiameter/p_dw.c	(revision 258)
@@ -3,5 +3,5 @@
 * Author: Sebastien Decugis <sdecugis@nict.go.jp>							 *
 *													 *
-* Copyright (c) 2009, WIDE Project and NICT								 *
+* Copyright (c) 2010, WIDE Project and NICT								 *
 * All rights reserved.											 *
 * 													 *
Index: freeDiameter/p_out.c
===================================================================
--- freeDiameter/p_out.c	(revision 229)
+++ freeDiameter/p_out.c	(revision 258)
@@ -3,5 +3,5 @@
 * Author: Sebastien Decugis <sdecugis@nict.go.jp>							 *
 *													 *
-* Copyright (c) 2009, WIDE Project and NICT								 *
+* Copyright (c) 2010, WIDE Project and NICT								 *
 * All rights reserved.											 *
 * 													 *
Index: freeDiameter/p_psm.c
===================================================================
--- freeDiameter/p_psm.c	(revision 229)
+++ freeDiameter/p_psm.c	(revision 258)
@@ -3,5 +3,5 @@
 * Author: Sebastien Decugis <sdecugis@nict.go.jp>							 *
 *													 *
-* Copyright (c) 2009, WIDE Project and NICT								 *
+* Copyright (c) 2010, WIDE Project and NICT								 *
 * All rights reserved.											 *
 * 													 *
Index: freeDiameter/p_sr.c
===================================================================
--- freeDiameter/p_sr.c	(revision 165)
+++ freeDiameter/p_sr.c	(revision 258)
@@ -3,5 +3,5 @@
 * Author: Sebastien Decugis <sdecugis@nict.go.jp>							 *
 *													 *
-* Copyright (c) 2009, WIDE Project and NICT								 *
+* Copyright (c) 2010, WIDE Project and NICT								 *
 * All rights reserved.											 *
 * 													 *
Index: freeDiameter/peers.c
===================================================================
--- freeDiameter/peers.c	(revision 175)
+++ freeDiameter/peers.c	(revision 258)
@@ -3,5 +3,5 @@
 * Author: Sebastien Decugis <sdecugis@nict.go.jp>							 *
 *													 *
-* Copyright (c) 2009, WIDE Project and NICT								 *
+* Copyright (c) 2010, WIDE Project and NICT								 *
 * All rights reserved.											 *
 * 													 *
Index: freeDiameter/routing_dispatch.c
===================================================================
--- freeDiameter/routing_dispatch.c	(revision 253)
+++ freeDiameter/routing_dispatch.c	(revision 258)
@@ -3,5 +3,5 @@
 * Author: Sebastien Decugis <sdecugis@nict.go.jp>							 *
 *													 *
-* Copyright (c) 2009, WIDE Project and NICT								 *
+* Copyright (c) 2010, WIDE Project and NICT								 *
 * All rights reserved.											 *
 * 													 *
Index: freeDiameter/sctp.c
===================================================================
--- freeDiameter/sctp.c	(revision 252)
+++ freeDiameter/sctp.c	(revision 258)
@@ -3,5 +3,5 @@
 * Author: Sebastien Decugis <sdecugis@nict.go.jp>							 *
 *													 *
-* Copyright (c) 2009, WIDE Project and NICT								 *
+* Copyright (c) 2010, WIDE Project and NICT								 *
 * All rights reserved.											 *
 * 													 *
Index: freeDiameter/sctps.c
===================================================================
--- freeDiameter/sctps.c	(revision 228)
+++ freeDiameter/sctps.c	(revision 258)
@@ -3,5 +3,5 @@
 * Author: Sebastien Decugis <sdecugis@nict.go.jp>							 *
 *													 *
-* Copyright (c) 2009, WIDE Project and NICT								 *
+* Copyright (c) 2010, WIDE Project and NICT								 *
 * All rights reserved.											 *
 * 													 *
Index: freeDiameter/server.c
===================================================================
--- freeDiameter/server.c	(revision 227)
+++ freeDiameter/server.c	(revision 258)
@@ -3,5 +3,5 @@
 * Author: Sebastien Decugis <sdecugis@nict.go.jp>							 *
 *													 *
-* Copyright (c) 2009, WIDE Project and NICT								 *
+* Copyright (c) 2010, WIDE Project and NICT								 *
 * All rights reserved.											 *
 * 													 *
Index: freeDiameter/tcp.c
===================================================================
--- freeDiameter/tcp.c	(revision 252)
+++ freeDiameter/tcp.c	(revision 258)
@@ -3,5 +3,5 @@
 * Author: Sebastien Decugis <sdecugis@nict.go.jp>							 *
 *													 *
-* Copyright (c) 2009, WIDE Project and NICT								 *
+* Copyright (c) 2010, WIDE Project and NICT								 *
 * All rights reserved.											 *
 * 													 *
Index: freeDiameter/tests/testcnx.c
===================================================================
--- freeDiameter/tests/testcnx.c	(revision 246)
+++ freeDiameter/tests/testcnx.c	(revision 258)
@@ -3,5 +3,5 @@
 * Author: Sebastien Decugis <sdecugis@nict.go.jp>							 *
 *													 *
-* Copyright (c) 2009, WIDE Project and NICT								 *
+* Copyright (c) 2010, WIDE Project and NICT								 *
 * All rights reserved.											 *
 * 													 *
Index: freeDiameter/tests/tests.h
===================================================================
--- freeDiameter/tests/tests.h	(revision 236)
+++ freeDiameter/tests/tests.h	(revision 258)
@@ -3,5 +3,5 @@
 * Author: Sebastien Decugis <sdecugis@nict.go.jp>							 *
 *													 *
-* Copyright (c) 2009, WIDE Project and NICT								 *
+* Copyright (c) 2010, WIDE Project and NICT								 *
 * All rights reserved.											 *
 * 													 *
Index: freeDiameter/tests/testsess.c
===================================================================
--- freeDiameter/tests/testsess.c	(revision 249)
+++ freeDiameter/tests/testsess.c	(revision 258)
@@ -3,5 +3,5 @@
 * Author: Sebastien Decugis <sdecugis@nict.go.jp>							 *
 *													 *
-* Copyright (c) 2009, WIDE Project and NICT								 *
+* Copyright (c) 2010, WIDE Project and NICT								 *
 * All rights reserved.											 *
 * 													 *
Index: include/freeDiameter/freeDiameter.h
===================================================================
--- include/freeDiameter/freeDiameter.h	(revision 253)
+++ include/freeDiameter/freeDiameter.h	(revision 258)
@@ -3,5 +3,5 @@
 * Author: Sebastien Decugis <sdecugis@nict.go.jp>							 *
 *													 *
-* Copyright (c) 2009, WIDE Project and NICT								 *
+* Copyright (c) 2010, WIDE Project and NICT								 *
 * All rights reserved.											 *
 * 													 *
Index: include/freeDiameter/libfreeDiameter.h
===================================================================
--- include/freeDiameter/libfreeDiameter.h	(revision 246)
+++ include/freeDiameter/libfreeDiameter.h	(revision 258)
@@ -3,5 +3,5 @@
 * Author: Sebastien Decugis <sdecugis@nict.go.jp>							 *
 *													 *
-* Copyright (c) 2009, WIDE Project and NICT								 *
+* Copyright (c) 2010, WIDE Project and NICT								 *
 * All rights reserved.											 *
 * 													 *
Index: libfreeDiameter/dictionary.c
===================================================================
--- libfreeDiameter/dictionary.c	(revision 173)
+++ libfreeDiameter/dictionary.c	(revision 258)
@@ -3,5 +3,5 @@
 * Author: Sebastien Decugis <sdecugis@nict.go.jp>							 *
 *													 *
-* Copyright (c) 2009, WIDE Project and NICT								 *
+* Copyright (c) 2010, WIDE Project and NICT								 *
 * All rights reserved.											 *
 * 													 *
Index: libfreeDiameter/fifo.c
===================================================================
--- libfreeDiameter/fifo.c	(revision 156)
+++ libfreeDiameter/fifo.c	(revision 258)
@@ -3,5 +3,5 @@
 * Author: Sebastien Decugis <sdecugis@nict.go.jp>							 *
 *													 *
-* Copyright (c) 2008, WIDE Project and NICT								 *
+* Copyright (c) 2010, WIDE Project and NICT								 *
 * All rights reserved.											 *
 * 													 *
Index: libfreeDiameter/init.c
===================================================================
--- libfreeDiameter/init.c	(revision 235)
+++ libfreeDiameter/init.c	(revision 258)
@@ -3,5 +3,5 @@
 * Author: Sebastien Decugis <sdecugis@nict.go.jp>							 *
 *													 *
-* Copyright (c) 2009, WIDE Project and NICT								 *
+* Copyright (c) 2010, WIDE Project and NICT								 *
 * All rights reserved.											 *
 * 													 *
Index: libfreeDiameter/libfD.h
===================================================================
--- libfreeDiameter/libfD.h	(revision 235)
+++ libfreeDiameter/libfD.h	(revision 258)
@@ -3,5 +3,5 @@
 * Author: Sebastien Decugis <sdecugis@nict.go.jp>							 *
 *													 *
-* Copyright (c) 2009, WIDE Project and NICT								 *
+* Copyright (c) 2010, WIDE Project and NICT								 *
 * All rights reserved.											 *
 * 													 *
Index: libfreeDiameter/log.c
===================================================================
--- libfreeDiameter/log.c	(revision 200)
+++ libfreeDiameter/log.c	(revision 258)
@@ -3,5 +3,5 @@
 * Author: Sebastien Decugis <sdecugis@nict.go.jp>							 *
 *													 *
-* Copyright (c) 2009, WIDE Project and NICT								 *
+* Copyright (c) 2010, WIDE Project and NICT								 *
 * All rights reserved.											 *
 * 													 *
Index: libfreeDiameter/messages.c
===================================================================
--- libfreeDiameter/messages.c	(revision 156)
+++ libfreeDiameter/messages.c	(revision 258)
@@ -3,5 +3,5 @@
 * Author: Sebastien Decugis <sdecugis@nict.go.jp>							 *
 *													 *
-* Copyright (c) 2009, WIDE Project and NICT								 *
+* Copyright (c) 2010, WIDE Project and NICT								 *
 * All rights reserved.											 *
 * 													 *
Index: libfreeDiameter/rt_data.c
===================================================================
--- libfreeDiameter/rt_data.c	(revision 168)
+++ libfreeDiameter/rt_data.c	(revision 258)
@@ -3,5 +3,5 @@
 * Author: Sebastien Decugis <sdecugis@nict.go.jp>							 *
 *													 *
-* Copyright (c) 2009, WIDE Project and NICT								 *
+* Copyright (c) 2010, WIDE Project and NICT								 *
 * All rights reserved.											 *
 * 													 *
Index: libfreeDiameter/sessions.c
===================================================================
--- libfreeDiameter/sessions.c	(revision 235)
+++ libfreeDiameter/sessions.c	(revision 258)
@@ -3,5 +3,5 @@
 * Author: Sebastien Decugis <sdecugis@nict.go.jp>							 *
 *													 *
-* Copyright (c) 2009, WIDE Project and NICT								 *
+* Copyright (c) 2010, WIDE Project and NICT								 *
 * All rights reserved.											 *
 * 													 *
Index: libfreeDiameter/signal.c
===================================================================
--- libfreeDiameter/signal.c	(revision 236)
+++ libfreeDiameter/signal.c	(revision 258)
@@ -3,5 +3,5 @@
 * Author: Sebastien Decugis <sdecugis@nict.go.jp>							 *
 *													 *
-* Copyright (c) 2009, WIDE Project and NICT								 *
+* Copyright (c) 2010, WIDE Project and NICT								 *
 * All rights reserved.											 *
 * 													 *